SystemOrganization addCategory: #'Glamour-Presentations'!

GLMPresentation subclass: #GLMDynamicPresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMDynamicPresentation methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 15:12'!
currentPresentation 
	^ self displayValue pane: self pane! !

!GLMDynamicPresentation methodsFor: 'as yet unclassified' stamp: 'tg 9/11/2009 15:12'!
renderGlamorouslyOn: aRenderer 
	^ self currentPresentation renderGlamorouslyOn: aRenderer! !

GLMPresentation subclass: #GLMFlexiblePresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMFlexiblePresentation commentStamp: '<historical>' prior: 0!
A presentation that flexibly changes it behavior depending on the current entity.

If the entity is a collection, this class renders as a ListPresentation, otherwise as a TextPresentation.!

!GLMFlexiblePresentation methodsFor: 'accessing' stamp: 'tg 5/24/2009 19:21'!
currentPresentation 
	 
	^ (self displayValue isCollection and: [self displayValue isString not])
		ifTrue: [GLMListPresentation new pane: self pane]
		ifFalse: [GLMTextPresentation new pane: self pane]! !

!GLMFlexiblePresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^self currentPresentation renderGlamorouslyOn: aRenderer! !

GLMPresentation subclass: #GLMFormatedPresentation
	instanceVariableNames: 'format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMFormatedPresentation classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
formater: aBlock 
	 
	^(self new) 
		formater: aBlock; 
		yourself! !

!GLMFormatedPresentation methodsFor: 'private' stamp: ' 4/5/09 22:18'!
defaultFormater 
	 
	^#glamourString! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
format 
	 
	^format ifNil: [format := self defaultFormater]! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
format: anObject 
	 
	format := anObject! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/9/2009 00:58'!
formatedDisplayValue
	^ self format glamourValue: self displayValue! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: 'tg 9/9/2009 01:03'!
formatedDisplayValueOf: anObject
	^ self format glamourValue: (anObject asGlamorousMultiValue, self entity asGlamorousMultiValue)! !

GLMFormatedPresentation subclass: #GLMListPresentation
	instanceVariableNames: 'highlightPort itemActions searchBlock filterBlock menu allowsInput allowsMultipleSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 8/4/2009 14:46'!
allowsInput
	^ allowsInput ifNil: [ allowsInput := false ]! !

!GLMListPresentation methodsFor: 'accessing' stamp: 'jorge.ressia 5/26/2009 11:59'!
filterStrategy
	^filterBlock! !

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 8/7/2009 01:03'!
isMultiple
	^ allowsMultipleSelection ifNil: [ allowsMultipleSelection := false ]! !

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 5/20/2009 14:06'!
isSingle 
	^ self isMultiple not! !

!GLMListPresentation methodsFor: 'rendering' stamp: 'tg 8/7/2009 01:02'!
renderGlamorouslyOn: aRenderer 
	^aRenderer renderListPresentation: self! !

GLMFormatedPresentation subclass: #GLMTextPresentation
	instanceVariableNames: 'text selectedText cursorPosition selectedTextBlock highlightSmalltalk highlightSmalltalkContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
cursorPosition 
	 
	^cursorPosition! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
cursorPosition: anObject 
	 
	cursorPosition := anObject! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/26/2009 21:04'!
forSmalltalk
	highlightSmalltalk := true! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:40'!
forSmalltalk: aBlock
	highlightSmalltalk := true.
	highlightSmalltalkContext := aBlock.! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:44'!
highlightSmalltalk
	^ highlightSmalltalk ifNil: [highlightSmalltalk := false]! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/31/2009 11:42'!
highlightSmalltalkContext
	^ highlightSmalltalkContext isNil 
		ifTrue: [nil] 
		ifFalse: [highlightSmalltalkContext glamourValue: self entity]! !

!GLMTextPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTextPresentation: self! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/7/2009 01:24'!
selectedText
	^ selectedText isNil 
		ifTrue: [self selectedTextBlock value]
		ifFalse: [selectedText]! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/7/2009 01:11'!
selectedText: anObject
	selectedText := anObject! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/7/2009 01:24'!
selectedTextBlock
	^ selectedTextBlock ifNil: [ [''] ]! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/7/2009 01:13'!
selectedTextBlock: anObject
	selectedTextBlock := anObject! !

!GLMTextPresentation methodsFor: 'accessing' stamp: 'tg 8/4/2009 15:34'!
selection 
	 
	^selectedText! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
text 
	 
	^text ifNil: [text := self formatedDisplayValue]! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
text: anObject 
	 
	text := anObject! !

GLMFormatedPresentation subclass: #GLMTreePresentation
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMTreePresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children 
	 
	^children! !

!GLMTreePresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children: anObject 
	 
	children := anObject! !

!GLMTreePresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTreePresentation: self! !

GLMPresentation subclass: #GLMMondrianPresentation
	instanceVariableNames: 'painting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting 
	 
	^painting! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting: anObject 
	 
	painting := anObject! !

!GLMMondrianPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderMondrianPresentation: self! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
renderOn: aView 
	 
	self painting 
		glamourValue: 
			((self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity] 
				ifFalse: 
					[GLMMultiValue 
						with: aView 
						with: self entity])! !
